
import { useState,  useEffect } from 'react';

import Request, {YWRequestConfig} from '@ywfe/request';
// @ts-ignore
import * as querystring from 'querystring';
// @ts-ignore
import { ParsedUrlQueryInput } from 'querystring';
// @ts-ignore
import * as R from 'ramda';
import {configs} from './config';


  const projectId = "PROAUTH";
  let env;
  if(typeof window === 'undefined'){
    env = (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  } else {
    env = window.localStorage.getItem('env') || (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  }
  
  const basePath = configs[projectId] ? configs[projectId][env].API_BASE_URL + `${env === 'mock' ? '/' + 88 : ''}` : '';
  const loginPath = configs['AUTH'] ? configs['AUTH'][env].APPLICATION_URL : '';
  

  

// @ts-ignore




export interface UserUpdatepasswdInput {
  
    
    /** 老密码 */
    oldPasswd?: string;
  
    
    /** 新密码 */
    newPasswd?: string;
  
}

export interface UserUpdatepasswdData {
  
}


const reduceParams = (data: R.Dictionary<UserUpdatepasswdInput>) => {
  if(data instanceof FormData){
    return data;
  }
  const result = R.filter(item => !R.isNil(item) && !R.isEmpty(item))(data) || {};
  return result as unknown as UserUpdatepasswdInput;
}


// 17320 修改密码

  export const usePostUserUpdatepasswd = () => {
    let isMount = true;
    const [isUserUpdatepasswdLoading, setIsUserUpdatepasswdLoading] = useState(false);
    const [dataUserUpdatepasswd, setDataUserUpdatepasswd] = useState<UserUpdatepasswdData>({} as UserUpdatepasswdData);
    const postUserUpdatepasswdData = async(inputs: UserUpdatepasswdInput, config?: YWRequestConfig): Promise<UserUpdatepasswdData> => {
      
        const params = reduceParams(inputs as unknown as R.Dictionary<UserUpdatepasswdInput>) || {};
      
      if(isMount){
        setIsUserUpdatepasswdLoading(true);
      }
      
      try{
        
          
          
          const res: any = await Request.post<UserUpdatepasswdData>(`${basePath}/user/updatePassWd`, params, {
            loginHost: loginPath,
            ...config
          });
          
          
          if(isMount){
            setDataUserUpdatepasswd(res || {});
            setIsUserUpdatepasswdLoading(false);
          }
          return res;
      } catch(error){
        console.log(error);
        if(isMount){
          setIsUserUpdatepasswdLoading(false);
        }
        return false as unknown as UserUpdatepasswdData;
      }
      
    }

    useEffect(() => {
      return () => {
        isMount = false;
      };
    }, []);
  
    return {
      isUserUpdatepasswdLoading,
      dataUserUpdatepasswd,
      postUserUpdatepasswdData,
    }
  }

